﻿using Tuitio.Application.Services;
using Tuitio.Application.Services.Abstractions;
using Tuitio.Application.Stores;
using Tuitio.Domain.Abstractions;
using Microsoft.Extensions.DependencyInjection;

namespace Tuitio.Application
{
    public static class DependencyInjectionExtensions
    {
        public static void AddApplicationServices(this IServiceCollection services)
        {
            services.AddStores();
            services.AddSingleton<IConfigProvider, ConfigProvider>();
            services.AddSingleton<IHashingService, HashingService>();
            services.AddSingleton<ITokenService, TokenService>();
            services.AddScoped<IUserService, UserService>();
            services.AddSingleton<IBehaviorService, BehaviorService>();
        }

        private static void AddStores(this IServiceCollection services)
        {
            services.AddSingleton<ITokenStore, TokenStore>();
        }
    }
}
